import 'package:mpv/mpv.dart';
import 'sample_view.dart';

class SamplePresenter extends Presenter<SampleView> {
  int count = 0;

  SamplePresenter(SampleView view) : super(view) {
    view.counter.add(CounterState(count));
  }

  /// request wraps the future in [CancelableFuture] and add to stack
  /// future result will not be applied if request with the same key
  increment() {
    final cancelKey = "increment";

    view.counter.add(CounterState(count, isProgress: true));

    cancelable(
      cancelKey,
      Future.delayed(Duration(seconds: 1)),
    ).then((_) {
      count++;
      view.counter.add(CounterState(count));
    });
  }
}
