import 'package:flutter/material.dart';
import 'package:mpv/mpv.dart';

import 'sample_presenter.dart';
import 'sample_view.dart';

class SampleWidget extends StatefulWidget {
  @override
  _SampleWidgetState createState() => _SampleWidgetState();
}

class _SampleWidgetState
    extends StateWithPresenter<SampleWidget, SamplePresenter> with SampleView {
  @override
  SamplePresenter createPresenter() {
    return SamplePresenter(this);
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(),
      body: Center(
        child: StreamWidget<CounterState>(counter, (context, state) {
          if (state?.isProgress != false) {
            return CircularProgressIndicator();
          }
          return Text(state.count.toString());
        }),
      ),
      floatingActionButton: FloatingActionButton(
        child: Icon(Icons.add),
        onPressed: () {
          presenter.increment();
        },
      ),
    );
  }
}
